<!--
    Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)
    
    SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import Modal from '@/components/general/Modal.vue';
import Input from '@/components/general/form/Input.vue';
import { computed, inject, nextTick } from 'vue';
import { itemEnum } from '@/enums/enums';
import BoxSelector from "@/components/general/form/BoxSelector.vue";
import { useDashboardStore } from '@/stores/dashboard';
import { storeToRefs } from 'pinia';
import { handleModeEnum } from '@/enums/enums';
import { request } from '@/lib/request';
import ColorSwatch from '@/components/general/form/ColorSwatch.vue';

const store = useDashboardStore();
const { folderColor, folderId, folderName, folderParent, handleMode, folders } = storeToRefs(store);
const oldFolder = store.folderId;
const emits = defineEmits<{
    (e: 'submit'): void,
    (e: 'cancel'): void
}>();

let configuration = inject<any>('configuration');
const folderColors = configuration.style.folderColors;
const submit = async () => {
    const data = {
        color: folderColor.value,
        id: folderId.value,
        name: folderName.value,
        parent: folderParent.value
    }
    const id = handleMode.value === handleModeEnum.ADD ? folderParent.value : folderId.value;
    const url = configuration.apiServer + `/api/overview/folder${id.length > 0 ? '/' + id : ''}`;
    const method = handleMode.value === handleModeEnum.ADD ? "POST" : "PUT";
    const response = await request(method, url, data, 'application/json', false, true);
    if (response && response.success) {
        store.reset();
        emits(`submit`);
    } else {
        console.error("ERROR");
    }
};
const cancel = () => {
    store.reset();
    emits(`cancel`);
};

const openDelete = () => {
    handleMode.value = handleModeEnum.NONE;
    nextTick(() => {
        handleMode.value = handleModeEnum.DELETE;
    });
}

const filteredFolders = computed(() => {
    return folders.value?.filter((folder) => folder.id !== oldFolder);
});

</script>
<template>
    <Modal
        :header="handleMode === handleModeEnum.ADD ? $t('dashboardPage.folder.create.label') : $t('dashboardPage.folder.edit.label')"
        :labelSubmit="handleMode === handleModeEnum.ADD ? $t('dashboardPage.folder.create.submit') : $t('dashboardPage.folder.edit.submit')"
        @submit="submit" :labelCancel="$t('general.buttons.cancel')" @cancel="cancel"
        :iconLeft="handleMode !== handleModeEnum.ADD ? 'true' : undefined" :tooltipLeft="$t('contentPage.deleteLabel')"
        iconLeftColor="text-red-700" @left="openDelete">
        <form @submit.prevent>
            <div class="px-0.5">
                <Input v-model="folderName" type="text" :label="$t('dashboardPage.folder.create.name')" />
                <label>{{ $t('dashboardPage.folder.create.main') }}</label>
                <select
                    class="bg-white w-full outline outline-1 outline-gray-300 px-2 py-1.5 focus:border-accent1-default rounded-md overflow-hidden text-ellipsis whitespace-nowrap"
                    v-model="folderParent">
                    <option value="">{{ $t('dashboardPage.folder.create.none') }}</option>
                    <option :key="index" :value="e.id" v-for="e, index in filteredFolders">{{ e.name }}</option>
                </select>
                <div class="flex flex-col gap-1">
                    <BoxSelector :label="$t('dashboardPage.folder.create.color')" v-model="folderColor" :items="folderColors"
                        :identifier="itemEnum.VALUE" type="colors" />
                    <ColorSwatch v-model="folderColor" />
                </div>
            </div>
        </form>
        <template #iconLeft><i class="ri-delete-bin-line ri-xl"></i></template>
</Modal></template>